"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generate = void 0;
const sdk_1 = require("@prisma/sdk");
const path_1 = __importDefault(require("path"));
const fs_1 = require("fs");
const removeDir_1 = __importDefault(require("./utils/removeDir"));
const writeFileSafely_1 = require("./utils/writeFileSafely");
const helpers_1 = require("./helpers");
async function generate(options) {
    const outputDir = (0, sdk_1.parseEnvValue)(options.generator.output);
    await fs_1.promises.mkdir(outputDir, { recursive: true });
    await (0, removeDir_1.default)(outputDir, true);
    const prismaClientProvider = options.otherGenerators.find((it) => (0, sdk_1.parseEnvValue)(it.provider) === 'prisma-client-js');
    const prismaClientPath = (0, sdk_1.parseEnvValue)(prismaClientProvider === null || prismaClientProvider === void 0 ? void 0 : prismaClientProvider.output);
    const prismaClientDmmf = (await Promise.resolve().then(() => __importStar(require(prismaClientPath))))
        .dmmf;
    const queries = [];
    const mutations = [];
    const subscriptions = [];
    prismaClientDmmf.mappings.modelOperations.forEach((modelOperation) => {
        const { model, plural, ...operations } = modelOperation;
        for (const [opType, opNameWithModel] of Object.entries(operations)) {
            if ([
                'findUnique',
                'findFirst',
                'findMany',
                'aggregate',
                'groupBy',
            ].includes(opType)) {
                queries.push(opNameWithModel);
            }
            if ([
                'create',
                'delete',
                'update',
                'deleteMany',
                'updateMany',
                'upsert',
            ].includes(opType)) {
                mutations.push(opNameWithModel);
            }
        }
    });
    queries.sort();
    mutations.sort();
    subscriptions.sort();
    const shieldText = (0, helpers_1.constructShield)({ queries, mutations, subscriptions });
    await (0, writeFileSafely_1.writeFileSafely)(path_1.default.join(outputDir, 'shield.ts'), shieldText);
}
exports.generate = generate;
//# sourceMappingURL=prisma-generator.js.map